﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class InformationGathering : MonoBehaviour {

	public SpriteRenderer leftText;
	public SpriteRenderer rightText;
	public GameObject lText;
	public GameObject rText;
	public Sprite readySprite;
	public Sprite otherReadySprite;
	public float minLY = 0;
	public float maxLY = 10;
	public float minRY = 0;
	public float maxRY = 10;
	bool leftReady = false;
	bool rightReady = false;
	public float moveValue = 2.78F;
	float first = 0F;
	float second = 0F;

	// Use this for initialization
	void Start () {
		
	}
	
	// Update is called once per frame
	void Update () {
		first = Mathf.Abs(Input.GetAxis("Vertical1")) > Mathf.Abs(Input.GetAxis("Vertical1K")) ? Input.GetAxis("Vertical1") : Input.GetAxis("Vertical1K");
		if (first != 0)
		{
			leftText.transform.position = new Vector3(leftText.transform.position.x, Mathf.Clamp(leftText.transform.position.y + first * moveValue * Time.deltaTime, minLY, maxLY), leftText.transform.position.z);
		}
		second = Mathf.Abs(Input.GetAxis("Vertical2")) > Mathf.Abs(Input.GetAxis("Vertical2K")) ? Input.GetAxis("Vertical2") : Input.GetAxis("Vertical2K");
		if (second != 0)
		{
			rightText.transform.position = new Vector3(rightText.transform.position.x, Mathf.Clamp(rightText.transform.position.y + second * moveValue * Time.deltaTime, minRY, maxRY), rightText.transform.position.z);
		}
		
		if (Input.GetKeyDown(KeyCode.Joystick1Button7) || Input.GetKeyDown(KeyCode.E) || Input.GetKeyDown(KeyCode.F)) //Input.GetKeyDown(KeyCode.Joystick1Button0) || 
		{
			if (rightReady)
			{
				SceneManager.LoadScene("MainScene");
				lText.GetComponent<SpriteRenderer>().sprite = readySprite;
				leftReady = true;
			}
			else if (!leftReady)
			{
				leftReady = true;
				lText.GetComponent<SpriteRenderer>().sprite = readySprite;
				rText.GetComponent<SpriteRenderer>().sprite = otherReadySprite;
			}
		}
		else if (Input.GetKeyDown(KeyCode.Joystick2Button7) || Input.GetKeyDown(KeyCode.Return)) //Input.GetKeyDown(KeyCode.Joystick2Button0) || 
		{
			if (leftReady)
			{
				SceneManager.LoadScene("MainScene");
				rText.GetComponent<SpriteRenderer>().sprite = readySprite;
				rightReady = true;
			}
			else if (!rightReady)
			{
				rightReady = true;
				lText.GetComponent<SpriteRenderer>().sprite = otherReadySprite;
				rText.GetComponent<SpriteRenderer>().sprite = readySprite;
			}
		}
	}
}
