﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

enum PedestrianType
{
	Question,
	Animal1,
	Animal2,
	Animal3,
	Animal4
}

public class Pedestrian : MonoBehaviour
{
	public SpriteRenderer sprite;
	float timeToCenter = 0F;
	bool comingFrom = false; //false left, true right
	//PedestrianType type = 0;
	int type = 0;
	const int xResolution = 1920;
	float distanceFromCenter = xResolution / 200F;
	float spriteXSize = 1F;
	float screenXCenter = xResolution / 200F;
	bool spawned = false;

	float requiredSpeed = 0F; //Required speed to reach the center in the specified time

	void Start () {
	}

	public void Initialize(float timeToCenter, bool comingFrom, int type, float screenXCenter, float yTransform = 0F)
	{
		this.timeToCenter = timeToCenter;
		this.comingFrom = comingFrom;
		this.type = type;
		this.screenXCenter = screenXCenter;

		spriteXSize = sprite.sprite.bounds.size.x;
		distanceFromCenter += spriteXSize / 2F;
		
		transform.position = new Vector3(screenXCenter + (distanceFromCenter * (comingFrom ? +1F : -1F)), yTransform, 0);
		sprite.sortingLayerName = "Pedestrian";

		if (comingFrom) //To check
		{
			sprite.flipX = true;
		}

		requiredSpeed = (distanceFromCenter / timeToCenter) * (comingFrom ? -1F : +1F);
	}
	
	void Update()
	{
		spawned = true;

		transform.position = new Vector3(transform.position.x + (requiredSpeed * Time.deltaTime), transform.position.y, transform.position.z);

		if (Mathf.Abs(transform.position.x - screenXCenter) > (xResolution / 200F) + (spriteXSize / 2F))
		{
			Destroy(gameObject);
		}
	}
	
	public bool IsInCenter(float screenXCenter)
	{
		return Mathf.Abs(transform.position.x - screenXCenter) <= spriteXSize / 2F;
	}
}