﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

//public class Question
//{
//	public string text = "";
//	public bool answer = false;
//	public Sprite sprite = null;

//	public Question(string text, bool answer, Sprite sprite)
//	{
//		this.text = text;
//		this.answer = answer;
//		this.sprite = sprite;
//	}
//}

public class Questions : MonoBehaviour
{
	const int questionsN = 8;

	//public Question[] leftQuestions;// = new Question[questionsN];
	//public Question[] rightQuestions;// = new Question[questionsN];
	//public string[] leftQStrings = new string[questionsN];
	public bool[] leftQAnswers = new bool[questionsN];
	public Sprite[] leftQSprites = new Sprite[questionsN];
	//public string[] rightQStrings = new string[questionsN];
	public bool[] rightQAnswers = new bool[questionsN];
	public Sprite[] rightQSprites = new Sprite[questionsN];
	public float[] questionTime = new float[questionsN] {3, 3, 3, 3, 3, 3, 3, 3};

	public Sprite[] llQSprites = new Sprite[questionsN];
	public Sprite[] lrQSprites = new Sprite[questionsN];
	public Sprite[] rlQSprites = new Sprite[questionsN];
	public Sprite[] rrQSprites = new Sprite[questionsN];

	public SyncroManager syncroManager;
	public GameObject lMatchScript;
	public GameObject rMatchScript;
	public GameObject lQuestion;
	public GameObject rQuestion;
	public GameObject llQuestion;
	public GameObject lrQuestion;
	public GameObject rlQuestion;
	public GameObject rrQuestion;
	public GameObject positveFeedbackSprite;
	public AudioSource startSong;
	public AudioSource positiveFeedback;
	public AudioSource negativeFeedback;
	public AudioSource waitSound;
	public AudioSource startEffect;
	public AudioSource loveEffect;
	public GameObject cuore;
	public GameObject leftPhone;
	public GameObject rightPhone;
	public Sprite three;
	public Sprite two;
	public Sprite one;
	public float initialSpawnTime = 3F;
	float currentSpawnTime = 3F;
	//float minSpawnTime = 0.8F;
	float lastTimer;
	float timer = 0F;
	bool befroreQCountDown = true;
	bool QCountDown = false;
	int currentQuestion = -1;
	int qCDcounter = 0;
	bool lDone = false;
	bool rDone = false;
	bool lBreaking = false;
	bool rBreaking = false;
	public float shortTime = 1F;
	public float answersFallingSpeed = 1F;
	public float answersFallingRot = 11F;
	public float answersFallingDist = 0.88F;
	GameObject[] cuori = new GameObject[6];
	public float cuoriSpeed = 3.93F;

	float lMatchT = 0F;
	float rMatchT = 0F;
	float lMatch = 0F;
	float rMatch = 0F;
	float match = 0F; //From 0 to 1
	public float matchLerpSpeed = 3;
	public float winningMatch = 0.7F;
	public float positiveAdds = 1F / 5F;
	public float negativeAdds = 1F / 12F;

	void Start ()
	{
		startSong.Play();
		llQuestion.transform.position = new Vector3(llQuestion.transform.position.x - answersFallingDist, llQuestion.transform.position.y, llQuestion.transform.position.z);
		lrQuestion.transform.position = new Vector3(lrQuestion.transform.position.x + answersFallingDist, lrQuestion.transform.position.y, lrQuestion.transform.position.z);
		rlQuestion.transform.position = new Vector3(rlQuestion.transform.position.x - answersFallingDist, rlQuestion.transform.position.y, rlQuestion.transform.position.z);
		rrQuestion.transform.position = new Vector3(rrQuestion.transform.position.x + answersFallingDist, rrQuestion.transform.position.y, rrQuestion.transform.position.z);
		llQuestion.transform.rotation = Quaternion.Euler(0, 0, answersFallingRot);
		lrQuestion.transform.rotation = Quaternion.Euler(0, 0, -answersFallingRot);
		rlQuestion.transform.rotation = Quaternion.Euler(0, 0, answersFallingRot);
		rrQuestion.transform.rotation = Quaternion.Euler(0, 0, -answersFallingRot);
	}
	
	void Update ()
	{
		if (Input.GetKey(KeyCode.Escape))
		{
			SceneManager.LoadScene("Menu");
		}

		timer += Time.deltaTime;
		if (currentQuestion >= questionsN)
		{
			if (match >= winningMatch)
			{
				lMatch = 1F;
				rMatch = 1F;

				leftPhone.SetActive(false);
				rightPhone.SetActive(false);

				GameObject mp = GameObject.FindGameObjectWithTag("MP");
				mp.transform.localPosition = Vector3.Lerp(mp.transform.localPosition, new Vector3(-1.61F, -4F, mp.transform.localPosition.z), 1 * Time.deltaTime);
				GameObject fp = GameObject.FindGameObjectWithTag("FP");
				fp.transform.localPosition = Vector3.Lerp(fp.transform.localPosition, new Vector3(1.01F, -4.33F, fp.transform.localPosition.z), 1 * Time.deltaTime);
				if (Vector3.Distance(mp.transform.localPosition, new Vector3(-1.61F, -4F, mp.transform.localPosition.z)) < 0.1F
					&& Vector3.Distance(fp.transform.localPosition, new Vector3(1.01F, -4.33F, fp.transform.localPosition.z)) < 0.1F)
				{
					timer += Time.deltaTime;

					if (timer < 0.36F && cuori[0] == null)
					{
						cuori[0] = Instantiate(cuore);
					}
					else if (timer >= 0.36F && cuori[1] == null)
					{
						cuori[1] = Instantiate(cuore);
						cuori[2] = Instantiate(cuore);
					}
					else if (timer > 0.71F && cuori[3] == null)
					{
						cuori[3] = Instantiate(cuore);
						cuori[4] = Instantiate(cuore);
					}
					else if(timer > 1F && cuori[5] == null)
					{
						cuori[5] = Instantiate(cuore);
					}
					else if (timer > 19F)
					{
						SceneManager.LoadScene("Menu");
					}

					if (cuori[0] != null)
					{
						cuori[0].transform.position = new Vector3(cuori[0].transform.position.x, cuori[0].transform.position.y + cuoriSpeed * Time.deltaTime, cuori[0].transform.position.z);
					}
					if (cuori[1] != null)
					{
						cuori[1].transform.position = new Vector3(cuori[1].transform.position.x + cuoriSpeed * Time.deltaTime * 0.7F, cuori[1].transform.position.y + cuoriSpeed * Time.deltaTime * 0.7F, cuori[1].transform.position.z);
					}
					if (cuori[2] != null)
					{
						cuori[2].transform.position = new Vector3(cuori[2].transform.position.x + cuoriSpeed * Time.deltaTime * -0.7F, cuori[2].transform.position.y + cuoriSpeed * Time.deltaTime * 0.7F, cuori[2].transform.position.z);
					}
					if (cuori[3] != null)
					{
						cuori[3].transform.position = new Vector3(cuori[3].transform.position.x + cuoriSpeed * Time.deltaTime, cuori[3].transform.position.y, cuori[3].transform.position.z);
					}
					if (cuori[4] != null)
					{
						cuori[4].transform.position = new Vector3(cuori[4].transform.position.x - cuoriSpeed * Time.deltaTime, cuori[4].transform.position.y, cuori[4].transform.position.z);
					}
					if (cuori[5] != null)
					{
						cuori[5].transform.position = new Vector3(cuori[5].transform.position.x, cuori[5].transform.position.y - cuoriSpeed * Time.deltaTime, cuori[5].transform.position.z);
					}
				}
				else
				{
					timer -= Time.deltaTime;
				}
			}
			else
			{
				lMatchT = 0F;
				rMatchT = 0F;
				SceneManager.LoadScene("GameOver");
			}
			//timer++...end game
		}
		else
		{
			if (lBreaking)
			{
				llQuestion.transform.position = new Vector3(llQuestion.transform.position.x, llQuestion.transform.position.y - answersFallingSpeed * Time.deltaTime, llQuestion.transform.position.z);
				lrQuestion.transform.position = new Vector3(lrQuestion.transform.position.x, lrQuestion.transform.position.y - answersFallingSpeed * Time.deltaTime, lrQuestion.transform.position.z);
				if (llQuestion.transform.position.y < -1.99F)
				{
					lBreaking = false;
					llQuestion.transform.position = lQuestion.transform.position;
					lrQuestion.transform.position = lQuestion.transform.position;
					llQuestion.transform.rotation = Quaternion.Euler(0, 0, answersFallingRot);
					lrQuestion.transform.rotation = Quaternion.Euler(0, 0, -answersFallingRot);
					llQuestion.GetComponent<SpriteRenderer>().enabled = false;
					lrQuestion.GetComponent<SpriteRenderer>().enabled = false;
				}
			}
			if (rBreaking)
			{
				rlQuestion.transform.position = new Vector3(rlQuestion.transform.position.x, rlQuestion.transform.position.y - answersFallingSpeed * Time.deltaTime, rlQuestion.transform.position.z);
				rrQuestion.transform.position = new Vector3(rrQuestion.transform.position.x, rrQuestion.transform.position.y - answersFallingSpeed * Time.deltaTime, rrQuestion.transform.position.z);
				if (rlQuestion.transform.position.y < -1.99F)
				{
					rBreaking = false;
					rlQuestion.transform.position = rQuestion.transform.position;
					rrQuestion.transform.position = rQuestion.transform.position;
					rlQuestion.transform.rotation = Quaternion.Euler(0, 0, answersFallingRot);
					rrQuestion.transform.rotation = Quaternion.Euler(0, 0, -answersFallingRot);
					rlQuestion.GetComponent<SpriteRenderer>().enabled = false;
					rrQuestion.GetComponent<SpriteRenderer>().enabled = false;
				}
			}
			if (befroreQCountDown)
			{
				if (timer > shortTime)
				{
					timer -= shortTime;
					qCDcounter++;

					if (qCDcounter == 2)
					{
						lQuestion.GetComponent<SpriteRenderer>().sprite = three;
						rQuestion.GetComponent<SpriteRenderer>().sprite = three;
					}
					else if (qCDcounter == 3)
					{
						lQuestion.GetComponent<SpriteRenderer>().sprite = two;
						rQuestion.GetComponent<SpriteRenderer>().sprite = two;
						waitSound.Play();
					}
					else if (qCDcounter == 4)
					{
						lQuestion.GetComponent<SpriteRenderer>().sprite = one;
						rQuestion.GetComponent<SpriteRenderer>().sprite = one;
					}
					else if (qCDcounter == 5)
					{
						qCDcounter = 0;
						timer = 0;
						currentQuestion++;
						if (currentQuestion < questionsN)
						{
							QCountDown = true;
							lQuestion.GetComponent<SpriteRenderer>().sprite = leftQSprites[currentQuestion];
							rQuestion.GetComponent<SpriteRenderer>().sprite = rightQSprites[currentQuestion];
							startEffect.Play();
						}
						else
						{
							lQuestion.GetComponent<SpriteRenderer>().sprite = null;
							rQuestion.GetComponent<SpriteRenderer>().sprite = null;
						}
						befroreQCountDown = false;
					}
					//lastTimer = timer;
					//currentSpawnTime -= 0.3F;
					//currentSpawnTime = Mathf.Max(currentSpawnTime, minSpawnTime);
					//GameObject pedestrian = Instantiate(pedestrianPrefab);
					//pedestrian.GetComponent<Pedestrian>().Initialize(2, Random.Range(0, 2) == 0 ? false : true, Random.Range(0, 4), 0F);
				}
			}
			else if (QCountDown)
			{
				if (timer > questionTime[currentQuestion])
				{
					timer = 0F;
					QCountDown = false;
					befroreQCountDown = true;
					if (!lDone || !rDone)
					{
						negativeFeedback.Play();
						if (!lDone)
						{
							lBreaking = true;
							llQuestion.GetComponent<SpriteRenderer>().enabled = true;
							llQuestion.GetComponent<SpriteRenderer>().sprite = llQSprites[currentQuestion];
							lrQuestion.GetComponent<SpriteRenderer>().enabled = true;
							lrQuestion.GetComponent<SpriteRenderer>().sprite = lrQSprites[currentQuestion];
						}
						if (!rDone)
						{
							rBreaking = true;
							rlQuestion.GetComponent<SpriteRenderer>().enabled = true;
							rlQuestion.GetComponent<SpriteRenderer>().sprite = rlQSprites[currentQuestion];
							rrQuestion.GetComponent<SpriteRenderer>().enabled = true;
							rrQuestion.GetComponent<SpriteRenderer>().sprite = rrQSprites[currentQuestion];
						}
					}
					lQuestion.GetComponent<SpriteRenderer>().sprite = null;
					rQuestion.GetComponent<SpriteRenderer>().sprite = null;
					lDone = false;
					rDone = false;
				}
				else
				{
					if (Input.GetButtonDown("Fire11") && !lDone)
					{
						lDone = true;
						if (leftQAnswers[currentQuestion] == true)
						{
							GameObject tempObj = Instantiate(positveFeedbackSprite);
							//tempObj.transform.position = GameObject.FindGameObjectWithTag("LP").transform.position;
							tempObj.transform.position = new Vector3(-6.26F, 0.6800001F, -7F);
							positiveFeedback.Play();
							lQuestion.GetComponent<SpriteRenderer>().sprite = null;
							lMatch += positiveAdds;
						}
						else
						{
							lBreaking = true;
							llQuestion.GetComponent<SpriteRenderer>().enabled = true;
							llQuestion.GetComponent<SpriteRenderer>().sprite = llQSprites[currentQuestion];
							lrQuestion.GetComponent<SpriteRenderer>().enabled = true;
							lrQuestion.GetComponent<SpriteRenderer>().sprite = lrQSprites[currentQuestion];

							negativeFeedback.Play();
							lQuestion.GetComponent<SpriteRenderer>().sprite = null;
							lMatch -= negativeAdds;
						}
					}
					else if (Input.GetButtonDown("Fire12") && !lDone)
					{
						lDone = true;
						if (leftQAnswers[currentQuestion] == false)
						{
							GameObject tempObj = Instantiate(positveFeedbackSprite);
							//tempObj.transform.position = GameObject.FindGameObjectWithTag("LP").transform.position;
							tempObj.transform.position = new Vector3(-6.26F, 0.6800001F, -7F);
							positiveFeedback.Play();
							lQuestion.GetComponent<SpriteRenderer>().sprite = null;
							lMatch += positiveAdds;
						}
						else
						{
							lBreaking = true;
							llQuestion.GetComponent<SpriteRenderer>().enabled = true;
							llQuestion.GetComponent<SpriteRenderer>().sprite = llQSprites[currentQuestion];
							lrQuestion.GetComponent<SpriteRenderer>().enabled = true;
							lrQuestion.GetComponent<SpriteRenderer>().sprite = lrQSprites[currentQuestion];

							negativeFeedback.Play();
							lQuestion.GetComponent<SpriteRenderer>().sprite = null;
							lMatch -= negativeAdds;
						}
					}
					if (Input.GetButtonDown("Fire21") && !rDone)
					{
						rDone = true;
						if (rightQAnswers[currentQuestion] == true)
						{
							GameObject tempObj = Instantiate(positveFeedbackSprite);
							//tempObj.transform.position = GameObject.FindGameObjectWithTag("RP").transform.position;
							tempObj.transform.position = new Vector3(6.84F, 0.6800001F, -7F);
							positiveFeedback.Play();
							rQuestion.GetComponent<SpriteRenderer>().sprite = null;
							rMatch += positiveAdds;
						}
						else
						{
							rBreaking = true;
							rlQuestion.GetComponent<SpriteRenderer>().enabled = true;
							rlQuestion.GetComponent<SpriteRenderer>().sprite = rlQSprites[currentQuestion];
							rrQuestion.GetComponent<SpriteRenderer>().enabled = true;
							rrQuestion.GetComponent<SpriteRenderer>().sprite = rrQSprites[currentQuestion];

							negativeFeedback.Play();
							rQuestion.GetComponent<SpriteRenderer>().sprite = null;
							rMatch -= negativeAdds;
						}
					}
					else if (Input.GetButtonDown("Fire22") && !rDone)
					{
						rDone = true;
						if (rightQAnswers[currentQuestion] == false)
						{
							GameObject tempObj = Instantiate(positveFeedbackSprite);
							//tempObj.transform.position = GameObject.FindGameObjectWithTag("RP").transform.position;
							tempObj.transform.position = new Vector3(6.84F, 0.6800001F, -7F);
							positiveFeedback.Play();
							rQuestion.GetComponent<SpriteRenderer>().sprite = null;
							rMatch += positiveAdds;
						}
						else
						{
							rBreaking = true;
							rlQuestion.GetComponent<SpriteRenderer>().enabled = true;
							rlQuestion.GetComponent<SpriteRenderer>().sprite = rlQSprites[currentQuestion];
							rrQuestion.GetComponent<SpriteRenderer>().enabled = true;
							rrQuestion.GetComponent<SpriteRenderer>().sprite = rrQSprites[currentQuestion];

							negativeFeedback.Play();
							rQuestion.GetComponent<SpriteRenderer>().sprite = null;
							rMatch -= negativeAdds;
						}
					}
				}
			}
		}

		lMatch += Mathf.Max(syncroManager.Syncronization - 0.5F, 0F) * Time.deltaTime / 50F;
		rMatch += Mathf.Max(syncroManager.Syncronization - 0.5F, 0F) * Time.deltaTime / 50F;
		lMatch = Mathf.Clamp(lMatch, 0, 1);
		rMatch = Mathf.Clamp(rMatch, 0, 1);
		match = (lMatch + rMatch) / 2F;

		lMatchT = Mathf.Lerp(lMatchT, lMatch, matchLerpSpeed * Time.deltaTime);
		rMatchT = Mathf.Lerp(rMatchT, rMatch, matchLerpSpeed * Time.deltaTime);
		if (lMatchT < 0.001F)
		{
			lMatchT = 0F;
		}
		if (lMatchT > 0.9994F)
		{
			lMatchT = 1F;
		}
		if (rMatchT < 0.001F)
		{
			rMatchT = 0F;
		}
		if (rMatchT > 0.9994F)
		{
			rMatchT = 1F;
		}

		float matchAvr = (lMatchT + rMatchT) / 2F;
		lMatchScript.GetComponent<BackgroudQuadFader>().SetShiftingPercentage(lMatchT);
		rMatchScript.GetComponent<BackgroudQuadFader>().SetShiftingPercentage(rMatchT);
		//lMatchScript.GetComponent<BackgroudQuadFader>().SetShiftingPercentage(matchAvr);
		//rMatchScript.GetComponent<BackgroudQuadFader>().SetShiftingPercentage(matchAvr);
	}

	//void OnGUI()
	//{
	//	GUI.Label(new Rect(0, 0, 100, 100), lMatch.ToString());
	//	GUI.Label(new Rect(0, 15, 100, 100), rMatchT.ToString());
	//}
}
