﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SpritesSequence : MonoBehaviour {

	public Sprite[] sprites;
	int currentSprite = 0;
	public float timer = 0.1F;
	float time = 0;
	float timeDeath = 0;
	public bool destroyAtEnd = true;
	public bool cycle = false;
	public float deathTimer = -1;
	// Use this for initialization
	void Start () {
		GetComponent<SpriteRenderer>().sprite = sprites[currentSprite];
	}
	
	// Update is called once per frame
	void Update () {
		time += Time.deltaTime;
		timeDeath += Time.deltaTime;

		if (deathTimer > 0 && timeDeath > deathTimer)
		{
			GetComponent<SpriteRenderer>().sprite = null;
			Destroy(this);
		}
		else if (time > timer)
		{
			time -= timer;
			currentSprite++;

			if (currentSprite >= sprites.Length)
			{
				if (destroyAtEnd)
				{
					GetComponent<SpriteRenderer>().sprite = null;
					Destroy(this);
				}
				else if (cycle)
				{
					currentSprite = 0;
					GetComponent<SpriteRenderer>().sprite = sprites[currentSprite];
				}
			}
			else
			{
				GetComponent<SpriteRenderer>().sprite = sprites[currentSprite];
			}
		}
	}
}
