﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SyncroManager : MonoBehaviour {

    public GameObject ManPlayer;
    public GameObject WomanPlayer;

    public GameObject SyncroGUIText;

    float _triggerAngle = 3f / 20f;

    float _syncronization = 500;

    public float Syncronization {  get { return Mathf.Clamp01(_syncronization / 1000f); } }

    WavingManager[] wavingMgr = new WavingManager[2];
    float[] oldValue = { 0, 0 };
    bool[] isInMov = { false, false };
    float[] timeMov = { 0, 0 };
    // Use this for initialization
    void Start () {
        wavingMgr[0] = ManPlayer.GetComponent<WavingManager>();
        wavingMgr[1] = WomanPlayer.GetComponent<WavingManager>();
    }

    // Update is called once per frame
    void Update ()
    {
        for (int i = 0; i < 2; ++i)
        {
            float delta = wavingMgr[i].WavePercentage - oldValue[i];
            if (!isInMov[i])
            {
                if(Mathf.Abs(delta) > _triggerAngle)
                {
                    isInMov[i] = true;
                    timeMov[i] = 0;
                }
            }
            else
            {
                if (Mathf.Abs(delta) < _triggerAngle && timeMov[i] > 0.5f )
                {
                    isInMov[i] = false;
                }
                timeMov[i] += Time.deltaTime;
                oldValue[i] += delta;
            }
        }

        float deltaSync = (1 - Mathf.Clamp01(Mathf.Abs(wavingMgr[0].WavePercentage - wavingMgr[1].WavePercentage)));
        if (isInMov[0] && isInMov[1] && deltaSync > 0.5f)
        {
            _syncronization += 20 * deltaSync;
        }
        else
        {
            if(!isInMov[0] || !isInMov[1])
            {
                _syncronization -= 10;
            }
            else
            {
                _syncronization -= 10 * (1 - deltaSync);
            }
        }

        _syncronization = Mathf.Clamp(_syncronization, 0, 1000);
        SyncroGUIText.GetComponent<TextMesh>().text = string.Format("{0:n3}", _syncronization);

    }
}
